/*
 * QTMoleculesView.hpp
 *
 *  Created on: Jan 21, 2010
 *      Author: crueger
 */

#ifndef QTMOLECULESVIEW_HPP_
#define QTMOLECULESVIEW_HPP_

#include <Qt/qtablewidget.h>
#include "Patterns/Observer.hpp"

class MoleculeListClass;

class QTMoleculesView : public QTableWidget, public Observer
{
  Q_OBJECT

public:
  QTMoleculesView(MoleculeListClass *_molecules,QWidget * _parent=0);
  virtual ~QTMoleculesView();

protected:
  virtual void update(Observable *publisher);
  virtual void subjectKilled(Observable *publisher);

  static const int COLUMNCOUNT;
  enum {NAME,ATOMS,CENTER,COLUMNTYPES_MAX} COLUMNTYPES;
  static const char *COLUMNNAMES[];

private slots:
  void moleculeChanged(int row, int column);

private:
  MoleculeListClass *molecules;
};

#endif /* QTMOLECULESVIEW_HPP_ */
